library(data.table)
library(ggplot2)
setwd("~/Google Drive/research/time_series_CI/code/")
source("ts_analysis_functions.R")

# Load the CSV file
dt.m <- fread("hedge_fund_data_with_data_ticketnumber.csv")
# Transform the exec agent to a factor
dt.m$execn_agent <- factor(dt.m$execn_agent)


pT <- list()
pT[[1]] <- c(rep(0.5, sum(dt.m[Market == "1"]$date < 
                   as.POSIXct("2016-07-12", format="%Y-%m-%d"))),
          c(rep(0.75, sum(dt.m[Market == "1"]$date >= 
                   as.POSIXct("2016-07-12", format="%Y-%m-%d")))))
pT[[2]] <- c(rep(0.5, sum(dt.m[Market == "2"]$date < 
                   as.POSIXct("2016-07-12", format="%Y-%m-%d"))),
          c(rep(0.5, sum(dt.m[Market == "2"]$date >= 
                   as.POSIXct("2016-07-12", format="%Y-%m-%d")))))
pT[[3]] <- c(rep(0.5, sum(dt.m[Market == "3"]$date < 
                   as.POSIXct("2016-07-12", format="%Y-%m-%d"))),
          c(rep(0.75, sum(dt.m[Market == "3"]$date >= 
                   as.POSIXct("2016-07-12", format="%Y-%m-%d")))))
pT[[4]] <- c(rep(0.5, sum(dt.m[Market == "4"]$date < 
                   as.POSIXct("2016-07-12", format="%Y-%m-%d"))),
          c(rep(0.5, sum(dt.m[Market == "4"]$date >= 
                   as.POSIXct("2016-07-12", format="%Y-%m-%d")))))
pT[[5]] <- c(rep(0.75, sum(dt.m[Market == "5"]$date < 
                   as.POSIXct("2016-07-12", format="%Y-%m-%d"))),
          c(rep(0.75, sum(dt.m[Market == "5"]$date >= 
                   as.POSIXct("2016-07-12", format="%Y-%m-%d")))))
pT[[6]] <- c(rep(0.5, sum(dt.m[Market == "6"]$date < 
                   as.POSIXct("2016-07-12", format="%Y-%m-%d"))),
          c(rep(0.5, sum(dt.m[Market == "6"]$date >= 
                   as.POSIXct("2016-07-12", format="%Y-%m-%d")))))
pT[[7]] <- c(rep(0.5, sum(dt.m[Market == "7"]$date < 
                   as.POSIXct("2016-07-12", format="%Y-%m-%d"))),
          c(rep(0.5, sum(dt.m[Market == "7"]$date >= 
                   as.POSIXct("2016-07-12", format="%Y-%m-%d")))))
pT[[8]] <- c(rep(0.5, sum(dt.m[Market == "8"]$date < 
                   as.POSIXct("2016-07-12", format="%Y-%m-%d"))),
          c(rep(0.5, sum(dt.m[Market == "8"]$date >= 
                   as.POSIXct("2016-07-12", format="%Y-%m-%d")))))
pT[[9]] <- c(rep(0.5, sum(dt.m[Market == "9"]$date < 
                   as.POSIXct("2016-07-12", format="%Y-%m-%d"))),
          c(rep(0.5, sum(dt.m[Market == "9"]$date >= 
                   as.POSIXct("2016-07-12", format="%Y-%m-%d")))))
pT[[10]] <- c(rep(0.5, sum(dt.m[Market == "10"]$date < 
                   as.POSIXct("2016-07-12", format="%Y-%m-%d"))),
          c(rep(0.75, sum(dt.m[Market == "10"]$date >= 
                   as.POSIXct("2016-07-12", format="%Y-%m-%d")))))

Yobs <- lapply(1:10, function(kk) dt.m[Market == as.character(kk)]$slippage)
Wobs <- lapply(1:10, function(kk) dt.m[Market == as.character(kk)]$execn_agent)

# Market level effects
pvr <- p.value.rand(Yobs[[2]], Wobs[[2]], pT[[2]], p.lag = 4, q.step = 0)
pvr$est
pvr$p.val

# Let's get some pooled results
pvn <- p.value.normal.pool(Yobs, Wobs, pT, p.lag = 0, q.step = 1)
round(pvn$CI, 3)
pvn$nu.est
pvn$p.val

pvf <- p.value.fisher.pool(Yobs, Wobs, pT, p.lag = 2, q.step = 1, normalize = TRUE)
pvf$nu.est
pvf$p.val


est.ht(Yobs[[2]], Wobs[[2]], pT[[2]], p.lag = 2, q.step = 0, normalize = TRUE)